/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the UnionRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &UnionRequest{}

// UnionRequest struct for UnionRequest
type UnionRequest struct {
	Source *string `json:"source,omitempty"`
	Target *string `json:"target,omitempty"`
}

// NewUnionRequest instantiates a new UnionRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewUnionRequest() *UnionRequest {
	this := UnionRequest{}
	return &this
}

// NewUnionRequestWithDefaults instantiates a new UnionRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewUnionRequestWithDefaults() *UnionRequest {
	this := UnionRequest{}
	return &this
}

// GetSource returns the Source field value if set, zero value otherwise.
func (o *UnionRequest) GetSource() string {
	if o == nil || IsNil(o.Source) {
		var ret string
		return ret
	}
	return *o.Source
}

// GetSourceOk returns a tuple with the Source field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UnionRequest) GetSourceOk() (*string, bool) {
	if o == nil || IsNil(o.Source) {
		return nil, false
	}
	return o.Source, true
}

// HasSource returns a boolean if a field has been set.
func (o *UnionRequest) HasSource() bool {
	if o != nil && !IsNil(o.Source) {
		return true
	}

	return false
}

// SetSource gets a reference to the given string and assigns it to the Source field.
func (o *UnionRequest) SetSource(v string) {
	o.Source = &v
}

// GetTarget returns the Target field value if set, zero value otherwise.
func (o *UnionRequest) GetTarget() string {
	if o == nil || IsNil(o.Target) {
		var ret string
		return ret
	}
	return *o.Target
}

// GetTargetOk returns a tuple with the Target field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UnionRequest) GetTargetOk() (*string, bool) {
	if o == nil || IsNil(o.Target) {
		return nil, false
	}
	return o.Target, true
}

// HasTarget returns a boolean if a field has been set.
func (o *UnionRequest) HasTarget() bool {
	if o != nil && !IsNil(o.Target) {
		return true
	}

	return false
}

// SetTarget gets a reference to the given string and assigns it to the Target field.
func (o *UnionRequest) SetTarget(v string) {
	o.Target = &v
}

func (o UnionRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o UnionRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Source) {
		toSerialize["source"] = o.Source
	}
	if !IsNil(o.Target) {
		toSerialize["target"] = o.Target
	}
	return toSerialize, nil
}

type NullableUnionRequest struct {
	value *UnionRequest
	isSet bool
}

func (v NullableUnionRequest) Get() *UnionRequest {
	return v.value
}

func (v *NullableUnionRequest) Set(val *UnionRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableUnionRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableUnionRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableUnionRequest(val *UnionRequest) *NullableUnionRequest {
	return &NullableUnionRequest{value: val, isSet: true}
}

func (v NullableUnionRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableUnionRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
